dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

FLD_HOME = gfs.getParentFolderName(wscript.scriptFullName) 
FLD_COLORS = gfs.buildPath(FLD_HOME, "colors")
FLD_PALETTES = gfs.buildPath(FLD_HOME, "Palettes")

'**** INCLUDED FILE: classes\_CINIFile.vbs ****
class CINIFile

    public aFile
    private lastIndex
    
    sub load(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile( pINIFile, 1, True )
		if not file.atendofstream then
			aFile = split(file.readAll(), vbCRLF)    
		end if		
		file.close
        
    end sub

    sub save(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile(pINIFile, 2, false)
        sFile = join(aFile, vbCRLF)
        file.write(sFile)
        file.close
        
    end sub


    function getKeyValue(pSection, pKey)
    
        index = findKey(pSection, pKey)
        
        splitLine = split(aFile(index), "=")
        getKeyValue = ""
        if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
            getKeyValue = splitLine(1)
        end if    

    end function 'getKeyValue

    
    function findKey(pSection, pKey)

        ' returns the line number of the found key, 0 if the keys does not exist
        ' and -1 if the section does not exist.
        
        ret = 0
        sectionFound = false
        index = -1
        for each line in aFile
            
            index = index + 1    
            trimmedLine = trim(line)             
            
            if NOT sectionFound then
          
                if replace(lcase(trimmedLine), lcase(pSection), "") = "[]" then
                    sectionFound = true
                end if    

            else
                
                if left(trimmedLine, 1) = "[" then
                    exit for
                else
                    splitLine = split(trimmedLine, "=")
                    
                    if ubound(splitLine) > -1 then
                        if lcase(trim(splitLine(0))) = lcase(pKey) then
                            ret = index
                            exit for
                        end if    
                    end if
                end if
            end if

        next

        lastIndex = index

        if not sectionFound then
            ret = -1
        end if    
            
        findKey = ret

    end function

    sub setKeyValue(pSection, pKey, pValue)
    
        index = findKey(pSection, pKey)
        if index > 0 then 
            splitLine = split(aFile(index), "=")
            if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                aFile(index) = splitLine(0) & "=" & pValue
            end if
        else
       
            if index = -1 then
                ubnd = ubound(aFile) + 2
                redim preserve aFile(ubnd)
                aFile(ubnd-1) = "[" & pSection & "]"
                aFile(ubnd) = pKey & "=" & pValue
                
            else 
                ubnd = ubound(aFile)
                redim preserve aFile(ubnd + 1)
                for i = ubnd to lastIndex + 1 step -1
                    aFile(i+1) = aFile(i) 
                next
                aFile(lastIndex+1) = pKey & "=" & pValue
            end if   
                
        end if            
    
    end sub 'setKeyValue

    
    public function findSections(pSection)
    
        set findSections = CreateObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if left(trimmedLine, len(pSection) + 1) = "[" & pSection then
                findSections.add mid(trimmedLine, 2, len(trimmedLine) - 2), ""
            end if
        next        

    end function
    
    function getSection(pSection)
    
        set getSection = createObject("Scripting.Dictionary")
        
        start = false
        for each line in aFile
            trimmedLine = trim(line)
            if start then
                if left(trimmedLine, 1) = "[" then
                    exit for
                end if
                if not trimmedLine = "" then
                    splitLine = split(trimmedLine, "=")
                    getSection.add splitLine(0), splitLine(1)
                 end if   
            end if
            if trimmedLine = "[" & pSection & "]" then
                start = true
            end if
        next
        
    end function

    
    public function nextSectionInstance(pSection)
    
        set sections = findSections(pSection)
        nextInstance = 0
        for each section in sections
            instance = replace(section, pSection, "")
            if isNumeric(instance) then
                if instance > nextInstance then
                    nextInstance = instance + 1
                end if
            end if
        next

        nextSectionInstance = pSection & nextInstance

                        
    end function    
              
    
    
    private sub Class_Initialize
        lastIndex = 0
		aFile = array()
    end sub

    
end class 'CINIFile


'**** END INCLUDED FILE: classes\_CINIFile.vbs ****

set easytileini = new CIniFile
easytileini.load gfs.buildPath(FLD_HOME, "easytile.ini")
easytileini.setkeyvalue "General", "TileColor", "EA005F"
easytileini.save gfs.buildPath(FLD_HOME, "easytile.ini")